﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using CustomGridColumnsDemo.Views;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Controls.Grids;

namespace CustomGridColumnsDemo.Assets.Columns
{
    public class ComboBoxColumnContentProvider : ColumnContentProviderBase
    {
        #region Members

        TextBlock _tb;
        ComboBox _combobox;

        #endregion

        #region Constructor

        public ComboBoxColumnContentProvider()
        {
            _tb = new TextBlock();
            _combobox = new ComboBox();
        }

        #endregion

        #region Overrides

        public override void AdjustDisplayElement(Cell cell)
        {
         
            base.AdjustDisplayElement(cell);
        }

        #region ResolveDisplayElement

        public override FrameworkElement ResolveDisplayElement(Cell cell, System.Windows.Data.Binding cellBinding)
        {
            ComboBoxColumn column = (ComboBoxColumn)cell.Column;

            List<ComboBoxColumnDemo.Equipment> equipments = new List<ComboBoxColumnDemo.Equipment>();
            Random c = new Random();
            equipments.Add(new ComboBoxColumnDemo.Equipment() { SeatName = "LighteningSeat" + (c.Next() % 10), WheelName = "LighteningWheel" });
            equipments.Add(new ComboBoxColumnDemo.Equipment() { SeatName = "LighteningSeat" + (c.Next() % 10), WheelName = "LighteningWheel2" });
            equipments.Add(new ComboBoxColumnDemo.Equipment() { SeatName = "DocSeat" + (c.Next() % 10), WheelName = "DocWheel" });
            equipments.Add(new ComboBoxColumnDemo.Equipment() { SeatName = "DocSeat" + (c.Next() % 10), WheelName = "DocWheel2" });

            this._combobox.SetValue(ComboBox.ItemsSourceProperty, equipments);

            if (column.DisplayMemberPath != null)
                this._combobox.SetValue(ComboBox.DisplayMemberPathProperty, column.DisplayMemberPath);

            Binding selectedItemBinding = new Binding
                                              {
                                                  Source = cell.Row.Data,
                                                  Path = new PropertyPath(column.Key),
                                                  Mode = BindingMode.TwoWay
                                              };

            this._combobox.SetBinding(ComboBox.SelectedItemProperty, selectedItemBinding);

            this._combobox.Style = cell.EditorStyleResolved;

            return this._combobox;
        }

        #endregion

        #region ResolveEditorControl

        protected override FrameworkElement ResolveEditorControl(Cell cell, object editorValue, double availableWidth, double availableHeight, System.Windows.Data.Binding editorBinding)
        {
            return ResolveDisplayElement(cell, editorBinding);
        }

        #endregion

        #region ResolveValueFromEditor

        public override object ResolveValueFromEditor(Infragistics.Controls.Grids.Cell cell)
        {
            return this._combobox.SelectedItem;
        }

        #endregion

        #endregion
    }
}
