﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using CustomGridColumnsDemo.Assets.Columns;
using Infragistics.Controls.Grids;

namespace CustomGridColumnsDemo.Views
{
    public partial class ComboBoxColumnDemo : Page
    {
        public ComboBoxColumnDemo()
        {
            InitializeComponent();
        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            List<Equipment> equipments = new List<Equipment>();
            equipments.Add(new Equipment() { SeatName = "LighteningSeat", WheelName = "LighteningWheel" });
            equipments.Add(new Equipment() { SeatName = "LighteningSeat2", WheelName = "LighteningWheel2" });
            equipments.Add(new Equipment() { SeatName = "DocSeat", WheelName = "DocWheel" });
            equipments.Add(new Equipment() { SeatName = "DocSeat2", WheelName = "DocWheel2" });
            equipments.Add(new Equipment() { SeatName = "MatorSeat", WheelName = "MatorWheel" });
            equipments.Add(new Equipment() { SeatName = "MatorSeat2", WheelName = "MatorWheel2" });
            equipments.Add(new Equipment() { SeatName = "SallySeat", WheelName = "SallyWheel" });
            equipments.Add(new Equipment() { SeatName = "SallySeat2", WheelName = "SallyWheel2" });

            List<Car> cars = new List<Car>();
            cars.Add(new Car() { Name = "Lightening", Equip = new ObservableCollection<Equipment>() {  } });
            cars.Add(new Car() { Name = "Doc", Equip = new ObservableCollection<Equipment>() { equipments[0], equipments[1] } });
            cars.Add(new Car() { Name = "Mator", Equip = new ObservableCollection<Equipment>() { equipments[2], equipments[3] } });
            cars.Add(new Car() { Name = "Sally", Equip = new ObservableCollection<Equipment>() { equipments[4], equipments[5] } });

            List<DemoData> data = new List<DemoData>();
            data.Add(new DemoData() { PropA = "A", PropB = 10, PropC = new ObservableCollection<Car>() { cars[0], cars[1] } });
            data.Add(new DemoData() { PropA = "B", PropB = 20, PropC = new ObservableCollection<Car>() { cars[1], cars[2] } });
            data.Add(new DemoData() { PropA = "C", PropB = 30, PropC = new ObservableCollection<Car>() { cars[2], cars[3] } });
            data.Add(new DemoData() { PropA = "D", PropB = 40, PropC = new ObservableCollection<Car>() { cars[3], cars[0] } });

            ((ComboBoxColumn)(((ColumnLayout)this.xamwebgrid1.Columns["PropC"]).Columns["Equip"])).ItemsSource = equipments;
            xamwebgrid1.ItemsSource = data;
        }

        public class DemoData
        {
            public string PropA { get; set; }
            public double PropB { get; set; }
            public ObservableCollection<Car> PropC { get; set; }
        }

        public class Car
        {
            public string Name { get; set; }
            public ObservableCollection<Equipment> Equip { get; set; }
        }

        public class Equipment
        {
            public string SeatName { get; set; }
            public string WheelName { get; set; }
        }

    }
}
